=== debian/changelog ===
libmongocrypt (1.4.0-1+rb2) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 18 Apr 2022 18:46:10 -0400

libmongocrypt (1.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 02 Mar 2022 14:05:42 -0500
