## libmongocrypt 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 if (CMAKE_VERSION VERSION_EQUAL 3.12 OR CMAKE_VERSION VERSION_GREATER 3.12)
    project (mongocrypt C)
+
+   # Used for the csfle-markup util:
+   enable_language (CXX OPTIONAL)
 else ()
    # GenerateExportHeader only works with C with 3.12 - https://gitlab.kitware.com/cmake/cmake/commit/de348a9638bd51af4523f36c68884b901d4aff18
    project (mongocrypt C CXX)
@@ -9,69 +12,46 @@
 
 set (CMAKE_C_STANDARD 99)
 
-option (ENABLE_SHARED_BSON "Dynamically link libbson (default is static)" OFF)
 option (ENABLE_STATIC "Install static libraries" ON)
 option (ENABLE_PIC
    "Enables building of position independent code for static library components."
    ON
 )
 option (ENABLE_BUILD_FOR_PPA "Maintainer-only option for preparing PPA build" OFF)
-if (ENABLE_SHARED_BSON AND ENABLE_BUILD_FOR_PPA)
+option (ENABLE_ONLINE_TESTS "Enable online tests and the csfle utility" ON)
+
+list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
+
+include (GNUInstallDirs)
+
+include (ImportBSON)
+
+if (USE_SHARED_LIBBSON AND ENABLE_BUILD_FOR_PPA)
    message (FATAL_ERROR "PPA build requires static linking to libbson")
 endif ()
-
-set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
-
 
 # Enable a higher warning level and warnings-as-errors
 include (MongoC-Warnings)
 option (ENABLE_MORE_WARNINGS_AS_ERRORS "Enable extra warnings-as-errors in the build." OFF)
 if (ENABLE_MORE_WARNINGS_AS_ERRORS)
    mongoc_add_platform_compile_options (
-      msvc:/W3 msvc:/WX msvc:/wd4996
+      msvc:/W3 msvc:/WX msvc:/wd4996 msvc:/wd4359
       gnu-like:-Wall gnu-like:-Werror
+      gnu-like:-Wswitch-enum gnu-like:-Wswitch-default
       )
 endif ()
 
-# Attempt to find libbson by new package name.
-find_package (bson-1.0 1.11 QUIET)
-if (bson-1.0_FOUND)
-   message ("--   libbson found version \"${bson-1.0_VERSION}\"")
-   set (BSON_TARGET mongo::bson_static)
-   if (ENABLE_SHARED_BSON)
-      set (BSON_TARGET mongo::bson_shared)
-   endif ()
-elseif (ENABLE_SHARED_BSON)
-   # Try old package name for libbson.
-   find_package (libbson-1.0 1.11 REQUIRED)
-   message ("--   libbson found version \"${BSON_VERSION}\"")
-   message ("--   libbson include path \"${BSON_INCLUDE_DIRS}\"")
-   message ("--   libbson libraries \"${BSON_LIBRARIES}\"")
-   set (BSON_TARGET ${BSON_LIBRARIES})
-   set (BSON_INCLUDES ${BSON_INCLUDE_DIRS})
-   set (BSON_DEFINITIONS ${BSON_DEFINITIONS})
-else ()
-   # Try old package name for libbson.
-   find_package (libbson-static-1.0 1.11 REQUIRED)
-   message ("--   libbson-static found version \"${BSON_STATIC_VERSION}\"")
-   message ("--   libbson-static include path \"${BSON_STATIC_INCLUDE_DIRS}\"")
-   message ("--   libbson-static libraries \"${BSON_STATIC_LIBRARIES}\"")
-   set (BSON_TARGET ${BSON_STATIC_LIBRARIES})
-   set (BSON_INCLUDES ${BSON_STATIC_INCLUDE_DIRS})
-   set (BSON_DEFINITIONS ${BSON_STATIC_DEFINITIONS})
-endif ()
-
-find_package ( Threads REQUIRED )
+find_package (Threads REQUIRED)
 
 add_subdirectory (bindings/cs)
 
 include (GenerateExportHeader)
-include (GNUInstallDirs)
 
 include (CTest)
 
 set (MONGOCRYPT_PUBLIC_HEADERS
    src/mongocrypt-compat.h
+   src/mongocrypt.h
 )
 
 set (MONGOCRYPT_SOURCES
@@ -79,6 +59,13 @@
    src/crypto/commoncrypto.c
    src/crypto/libcrypto.c
    src/crypto/none.c
+   src/mc-efc.c
+   src/mc-fle2-insert-update-payload.c
+   src/mc-fle2-encryption-placeholder.c
+   src/mc-fle2-find-equality-payload.c
+   src/mc-fle2-payload-ieev.c
+   src/mc-fle2-payload-uev.c
+   src/mc-tokens.c
    src/mongocrypt-binary.c
    src/mongocrypt-buffer.c
    src/mongocrypt-cache.c
@@ -90,6 +77,7 @@
    src/mongocrypt-ctx-datakey.c
    src/mongocrypt-ctx-decrypt.c
    src/mongocrypt-ctx-encrypt.c
+   src/mongocrypt-ctx-rewrap-many-datakey.c
    src/mongocrypt-ctx.c
    src/mongocrypt-endpoint.c
    src/mongocrypt-kek.c
@@ -155,6 +143,25 @@
    set (MONGOCRYPT_ENABLE_TRACE 1)
 endif ()
 
+set (BUILD_VERSION "0.0.0" CACHE STRING "Library version")
+if (BUILD_VERSION STREQUAL "0.0.0")
+   if (EXISTS ${PROJECT_SOURCE_DIR}/VERSION_CURRENT)
+      file (STRINGS ${PROJECT_SOURCE_DIR}/VERSION_CURRENT BUILD_VERSION)
+      message (STATUS "File VERSION_CURRENT contained BUILD_VERSION ${BUILD_VERSION}")
+   else ()
+      set (RELEASE_BRANCH_REF "origin/r1.5")
+      include (GetVersion)
+      GetVersion (BUILD_VERSION)
+      message (STATUS "Storing BUILD_VERSION ${BUILD_VERSION} in file VERSION_CURRENT for later use")
+      file (WRITE ${PROJECT_SOURCE_DIR}/VERSION_CURRENT ${BUILD_VERSION})
+   endif ()
+else ()
+   message (STATUS "Storing BUILD_VERSION ${BUILD_VERSION} in file VERSION_CURRENT for later use")
+   file (WRITE ${PROJECT_SOURCE_DIR}/VERSION_CURRENT ${BUILD_VERSION})
+endif ()
+
+set (MONGOCRYPT_BUILD_VERSION ${BUILD_VERSION})
+
 configure_file (
    "${PROJECT_SOURCE_DIR}/src/mongocrypt-config.h.in"
    "${PROJECT_BINARY_DIR}/src/mongocrypt-config.h"
@@ -169,6 +176,11 @@
    APPEND PROPERTY INTERFACE_COMPILE_DEFINITIONS
    MLIB_USER
    )
+set_property(
+   TARGET _mongo-mlib
+   APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES
+   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>"
+   )
 
 # kms-message
 add_subdirectory (kms-message)
@@ -180,23 +192,31 @@
    PRIVATE
       "${CMAKE_CURRENT_SOURCE_DIR}/kms-message/src"
       "${CMAKE_CURRENT_SOURCE_DIR}/src"
-      ${BSON_INCLUDES}
    PUBLIC
       "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>"
    )
-target_compile_definitions (mongocrypt PRIVATE ${BSON_DEFINITIONS})
+include (TestBigEndian)
+TEST_BIG_ENDIAN (MONGOCRYPT_BIG_ENDIAN)
+if (MONGOCRYPT_BIG_ENDIAN)
+   message ("Detected byte order: big endian")
+   list (APPEND MONGOCRYPT_DEFINITIONS MONGOCRYPT_BIG_ENDIAN)
+else ()
+   message ("Detected byte order: little endian")
+   list (APPEND MONGOCRYPT_DEFINITIONS MONGOCRYPT_LITTLE_ENDIAN)
+endif ()
+target_compile_definitions (mongocrypt PRIVATE ${MONGOCRYPT_DEFINITIONS})
 target_link_libraries (
    mongocrypt
    PRIVATE
-      ${BSON_TARGET}
-      ${CMAKE_THREAD_LIBS_INIT}
+      _mongocrypt::libbson_for_shared
+      Threads::Threads
       kms_message_static
       $<BUILD_INTERFACE:mongo::mlib>
    PUBLIC
       ${CMAKE_DL_LIBS}
    )
 
-if (NOT ENABLE_SHARED_BSON)
+if (NOT USE_SHARED_LIBBSON)
    if (APPLE)
       message ("compiling with unexported symbols list to hide bson symbols")
       set_target_properties (mongocrypt PROPERTIES LINK_FLAGS "-Wl,-unexported_symbols_list,\"${CMAKE_CURRENT_SOURCE_DIR}/cmake/libmongocrypt-hidden-symbols.txt\"")
@@ -223,14 +243,13 @@
    PRIVATE
       "${CMAKE_CURRENT_SOURCE_DIR}/kms-message/src"
       "${CMAKE_CURRENT_SOURCE_DIR}/src"
-      ${BSON_INCLUDES}
    PUBLIC
       "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/src>"
    )
 target_compile_definitions (
    mongocrypt_static
    PRIVATE
-      ${BSON_DEFINITIONS}
+      ${MONGOCRYPT_DEFINITIONS}
    PUBLIC
       MONGOCRYPT_STATIC_DEFINE
       KMS_MSG_STATIC
@@ -238,7 +257,7 @@
 target_link_libraries (
    mongocrypt_static
    PRIVATE
-      ${BSON_TARGET}
+      _mongocrypt::libbson_for_static
       kms_message_static
       $<BUILD_INTERFACE:mongo::mlib>
    PUBLIC
@@ -301,39 +320,26 @@
       PREFIX ""
       )
 
-   if (MONGOCRYPT_TESTING_CSFLE_FILE)
+   # Create two stubbed crypt_shared libraries
+   add_library (stubbed-crypt_shared SHARED test/crypt_shared-stub.cpp)
+   add_library (stubbed-crypt_shared-2 SHARED test/crypt_shared-stub.cpp)
+
+   set_target_properties(stubbed-crypt_shared stubbed-crypt_shared-2 PROPERTIES
+      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/src"
+      LINK_LIBRARIES _mongocrypt::libbson_for_static
+      COMPILE_FEATURES cxx_std_11
+      PREFIX ""
+      )
+
+   set_target_properties(stubbed-crypt_shared-2 PROPERTIES SUFFIX ".dll")
+
+   if (MONGOCRYPT_TESTING_CRYPT_SHARED_FILE)
       # Generate a target that copies the CSFLE library into the binary directory of test-mongocrypt
-      set (stamp "${CMAKE_CURRENT_BINARY_DIR}/mongo_csfle_v1.copied.$<CONFIG>.stamp")
+      set (stamp "${CMAKE_CURRENT_BINARY_DIR}/mongo_crypt_v1.copied.$<CONFIG>.stamp")
       add_custom_command (
          OUTPUT "${stamp}"
          COMMAND "${CMAKE_COMMAND}" -E copy
-            "${MONGOCRYPT_TESTING_CSFLE_FILE}"
-            "$<TARGET_FILE_DIR:test-mongocrypt>/mongo_csfle_v1${CMAKE_SHARED_LIBRARY_SUFFIX}"
+            "${MONGOCRYPT_TESTING_CRYPT_SHARED_FILE}"
+            "$<TARGET_FILE_DIR:test-mongocrypt>/mongo_crypt_v1${CMAKE_SHARED_LIBRARY_SUFFIX}"
          COMMAND "${CMAKE_COMMAND}" -E touch "${stamp}"
-         DEPENDS "${MONGOCRYPT_TESTING_CSFLE_FILE}"
-         COMMENT "Getting mongo_csfle library"
-         )
-      add_custom_target (copy-csfle ALL DEPENDS "${stamp}")
-   else ()
-      message (STATUS "Generating a stubbed csfle dynamic library for use in testing.")
-      message (STATUS "Provide a MONGOCRYPT_TESTING_CSFLE_FILE=<filepath> to provide a csfle for use in testing")
-      add_library (stubbed-csfle SHARED test/csfle-stub.cpp)
-      set_target_properties (stubbed-csfle PROPERTIES
-         # Normalize the output name expected by libmongocrypt
-         PREFIX ""
-         OUTPUT_NAME "mongo_csfle_v1"
-         )
-      target_include_directories (stubbed-csfle PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src)
-   endif ()
-endif ()
-
-set (TEST_MONGOCRYPT_SOURCES
-   test/test-mongocrypt-assert-match-bson.c
-   test/test-mongocrypt-buffer.c
-   test/test-mongocrypt-cache.c
-   test/test-mongocrypt-cache-oauth.c
-   test/test-mongocrypt-ciphertext.c
-   test/test-mongocrypt-crypto.c
-   test/test-mongocrypt-crypto-hooks.c
-   test/test-mongocrypt-csfle-lib.c
-   test/test-mongocrypt-ctx-decrypt.c
+         DEPENDS "${MONGOCRYPT_TESTING_CRYPT_SHARED_FILE}"
