=== kms-message/CMakeLists.txt ===
--- 
+++ 
@@ -264,21 +264,18 @@
 endif ()
 
 # build online_tests if OpenSSL is available (to create TLS connections).
-find_package (mongoc-1.0 1.16.2)
-if(NOT mongoc-1.0_FOUND)
-   message ("test_kms_azure_online target disabled: libmongoc not found. Required for creating TLS streams")
-elseif(DISABLE_NATIVE_CRYPTO)
+if(DISABLE_NATIVE_CRYPTO)
    message ("test_kms_azure_online target disabled: Not building with native crypto.")
 elseif(ENABLE_ONLINE_TESTS)
    add_executable(test_kms_azure_online test/test_kms_azure_online.c test/test_kms_util.c test/test_kms_online_util.c)
    target_include_directories(test_kms_azure_online PRIVATE ${PROJECT_SOURCE_DIR}/src)
    target_compile_definitions(test_kms_azure_online PRIVATE ${KMS_MESSAGE_DEFINITIONS})
-   target_link_libraries(test_kms_azure_online mongo::mongoc_shared)
+   target_link_libraries(test_kms_azure_online _mongocrypt::mongoc)
    target_link_libraries(test_kms_azure_online kms_message_static)
 
    add_executable(test_kms_gcp_online test/test_kms_gcp_online.c test/test_kms_util.c test/test_kms_online_util.c)
    target_include_directories(test_kms_gcp_online PRIVATE ${PROJECT_SOURCE_DIR}/src)
    target_compile_definitions(test_kms_gcp_online PRIVATE ${KMS_MESSAGE_DEFINITIONS})
-   target_link_libraries(test_kms_gcp_online mongo::mongoc_shared)
+   target_link_libraries(test_kms_gcp_online _mongocrypt::mongoc)
    target_link_libraries(test_kms_gcp_online kms_message_static)
 endif ()
