=== debian/changelog ===
libmongocrypt (1.5.2-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 30 Jul 2022 11:07:08 -0400

libmongocrypt (1.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Update to Standards-Version 4.6.1 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 28 Jun 2022 16:05:33 -0400

libmongocrypt (1.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 18 Apr 2022 18:46:10 -0400
