=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libssl-dev,
                pkg-config,
                libbson-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/mongodb/libmongocrypt
