## libmongocrypt 1.6.0

=== debian/changelog ===
libmongocrypt (1.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 07 Sep 2022 20:54:40 -0400
